moDraw.extraFields = {};

function moDraw.extraFields:setOpenField(self)
	if moGuiMiniPdaSlots.fieldsInfo.extraDrawField == nil or moGuiMiniPdaSlots.fieldsInfo.extraDrawField == 0 then return;end;	
	local fieldNum = moGuiMiniPdaSlots.fieldsInfo.extraDrawField;
	if moFields == nil or moFields[fieldNum] == nil then return;end;	
	local posX = 0.3;
	local posY = 0.7;
	local slot = moGuiMiniPdaSlots.fieldsInfo.extraDrawSlot;
	--moGuiMiniPdaSlots.values[slot].clickArea.slotFieldBuy = {};
	local seeSmall = moGuiMiniPdaSlots.values[slot].seeSmall;	
	if not seeSmall then moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall = {};end;
	local size = moGuiMiniPdaSlots.values[slot].size;
	local sizeTemp = 0.010;
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local distanceLine = moGuiMiniPdaSlots.values[slot].distanceLine;
	local width = slotLength+distanceDif;	
	if moGuiMiniPdaSlots.fieldsInfo.extraDrawPos == 0 then		
		posX = moGuiMiniPdaSlots.values[slot].openX+0.001;
		posY = moGuiMiniPdaSlots.values[slot].openY-moGuiMiniPdaSlots.values[slot].openLastHeight;
	elseif moGuiMiniPdaSlots.fieldsInfo.extraDrawPos == 1 then 
		if moGuiMiniPdaSlots.values[slot].openX+0.001 > 0.5 then posX = moGuiMiniPdaSlots.values[slot].openX-0.001-width;
		else posX = moGuiMiniPdaSlots.values[slot].openX+0.002+width;end;
		posY = moGuiMiniPdaSlots.values[slot].openY;
	end;
	local zoomOutIn = moGuiMiniPdaSlots.fieldsInfo.zoomOutInIcons;	
	local drawPos = moGuiMiniPdaSlots.fieldsInfo.extraDrawPos;	
	local height = moSetGetGui.buttonGfxHeight1*(size*1000);
	local heightDefault = moSetGetGui.buttonGfxHeight1*(size*1000);
	local widthIcon = moSetGetGui.buttonGfxWidth1*zoomOutIn*12;
	local heightIcon = moSetGetGui.buttonGfxHeight1*zoomOutIn*12;		
	local currentPosY = posY;		
	function nextLine(setHeight, posYnew, setLine, posYline, widthLine, heightLine, onlyLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-0.001, currentPosY-(posYline), widthLine, heightLine);
			moSetGetGui["designLine"]:render();
			if onlyLine then return;end;
		end;		
		if setHeight then height = height+(heightDefault)+posYnew;end; --height+size+posNew;
		currentPosY = currentPosY-(heightDefault)-posYnew; --posY-(size+posYnew);		
	end;	
	moSetGetGui["designGround"]:render();	
	setTextBold(true);	
	setTextColor(unpack(moGuiMiniPdaSlots.demandColor));	
	local multipleField = tostring(fieldNum);
	if moGuiMiniPdaSlots.fieldsInfo.calculation == 3 and moFieldDefNew ~= nil and moFieldDefNew[fieldNum].fieldNum ~= nil then
		local splitFieldNum = Utils.splitString(",", moFieldDefNew[fieldNum].fieldNum);		
		for a=1, #splitFieldNum do
			if splitFieldNum[a] ~= nil and string.len(splitFieldNum[a]) > 0 and tonumber(splitFieldNum[a]) ~= tonumber(fieldNum) then multipleField = multipleField.. ",".. splitFieldNum[a];end;
		end;		
	end;
	if moGuiMiniPdaSlots.fieldsInfo.autoCloseExtraDraw then
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("field")).. ": ".. tostring(multipleField).. " - ".. tostring(moGuiMiniPdaSlots.fieldsInfo.extraDrawEnd));
	else
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("field")).. ": ".. tostring(multipleField));
	end;	
	if moGuiMiniPdaSlots.fieldsInfo.seeSeeds then
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		setTextAlignment(RenderText.ALIGN_RIGHT);	
		renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].usageAreas).. "%");
		setTextAlignment(false);
	end;
	if not moFields[fieldNum].isBuy and not g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[fieldNum].ownedByPlayer then
		nextLine(true, 0.005);
		local price = g_i18n:formatMoney(moFields[fieldNum].price);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		if moFields.userId ~= nil and moFields.userId > 0 then
			local money = g_currentMission.missionStats.money;
			if money >= moFields[fieldNum].price then 
				setTextColor(unpack(moGuiMiniPdaSlots.warningColor0));
				--if moFields[fieldNum].fieldObject.fieldBuyTrigger ~= nil and moFields[a].fieldObject.fieldBuyTrigger ~= 0 then moDraw.extraFields:setClickAreaFieldBuy(self, posX, currentPosY, width/2, heightDefault, fieldNum, slot);end;
			else
				setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
			end;
		end;
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("price")).. ": ".. tostring(price));		
	end;
	if not moFields[fieldNum].cornerPoints and moGuiMiniPdaSlots.fieldsInfo.seeError then
		nextLine(true, 0.005);
		setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
		renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("f_error", nil, "Error Field")));
	end;
	nextLine(true, 0.007, true, 0.0035, width, 0.001);
	local saveCurrentPosY = currentPosY;	
	local foundFruits = 0;	
	--if moGuiMiniPdaSlots.fieldsInfo.iconDesign then
		
	--elseif not moGuiMiniPdaSlots.fieldsInfo.iconDesign then
		local posTxt = "";
		local posTxt1 = "";
		if moGuiMiniPdaSlots.fieldsInfo.seeHarvest and moFields[fieldNum].harvestAreas ~= 0 then
			setTextBold(true);
			foundFruits = Utils.getNoNil(moFields[fieldNum].harvestFruitsLength, 0);
			if foundFruits > 0 then posTxt = " (".. tostring(foundFruits).. ")";end;
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("f_harvest", nil, "Harvest")).. tostring(posTxt));
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);	
			renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].harvestAreas).. "%");
			setTextAlignment(false);
			posTxt = "";
			if foundFruits > 0 and not seeSmall then
				setTextBold(false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));				
				nextLine(true, distanceLine/2, false);
				--new user wunsch
				posTxt = tostring(moLanguageXml:getTxt("f_level", nil, "Stage")).. "[".. tostring(moFields[fieldNum].harvestLevel).. "]";
				renderText(posX, currentPosY, size, tostring(posTxt));
				setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
				setTextAlignment(RenderText.ALIGN_RIGHT);	
				renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].harvestProzent).. "%");
				setTextAlignment(false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				posTxt = "";
				nextLine(true, distanceLine/2, false);
				--new user wunsch
				for k,v in pairs(moFields[fieldNum].harvestFruits) do
					if string.len(posTxt) > 0 then posTxt = posTxt.. ",".. v.fruitName.. " ".. v.areas.. "%";
					else posTxt = v.fruitName.. " ".. v.areas.. "%";end;
					if moGuiMiniPdaSlots.fieldsInfo.seeFillLevel and v.fillLevel ~= nil then						
						if string.len(posTxt1) > 0 then posTxt1 = posTxt1.. ",".. v.fruitName.. "~".. tostring(v.fillLevel).. "L";
						else posTxt1 = v.fruitName.. "~".. tostring(v.fillLevel).. "L";end;
					end;
				end;
				local stringLength = moSetGetGui.buttonGfxWidth1*(sizeTemp*1000/1.5)*(string.len(posTxt)/1.05+(moSetGetGui.screenAspectRatio));				
				if tonumber(width) < tonumber(stringLength) then
					local splitNames = Utils.splitString(",", posTxt);
					moDraw.extraFields:setClickAreaSeeSmall(self, posX, currentPosY-(0.0025), width, heightDefault, posTxt, tostring(moLanguageXml:getTxt("f_harvest", nil, "Harvest")), slot);
					moSetGetGui["slotPlus"]:setPosition(posX, currentPosY-(0.0025));
					moSetGetGui["slotPlus"]:render();
					setTextAlignment(RenderText.ALIGN_RIGHT);
					posTxt = tostring(moLanguageXml:getTxt("toolong1")).. "(".. tostring(table.getn(splitNames)).. " ".. tostring(moLanguageXml:getTxt("toolong2")).. ")";
					renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(posTxt));
					setTextAlignment(false);
				else
					renderText(posX, currentPosY, sizeTemp, tostring(posTxt));
				end;
				if moGuiMiniPdaSlots.fieldsInfo.seeFillLevel then
					local stringLength1 = moSetGetGui.buttonGfxWidth1*(sizeTemp*1000/1.5)*(string.len(posTxt1)/1.05+(moSetGetGui.screenAspectRatio));
					if string.len(posTxt1) > 0 then
						nextLine(true, distanceLine/2, false);
						if tonumber(width) < tonumber(stringLength1) then
							local splitNames = Utils.splitString(",", posTxt1);
							moDraw.extraFields:setClickAreaSeeSmall(self, posX, currentPosY-(0.0025), width, heightDefault, posTxt1, tostring(moLanguageXml:getTxt("f_harvest", nil, "Harvest")), slot);
							moSetGetGui["slotPlus"]:setPosition(posX, currentPosY-(0.0025));
							moSetGetGui["slotPlus"]:render();
							setTextAlignment(RenderText.ALIGN_RIGHT);
							posTxt1 = tostring(moLanguageXml:getTxt("toolong1")).. "(".. tostring(table.getn(splitNames)).. " ".. tostring(moLanguageXml:getTxt("toolong2")).. ")";
							renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(posTxt1));
							setTextAlignment(false);
						else
							renderText(posX, currentPosY, sizeTemp, tostring(posTxt1));
						end;
					end;
				end;
			end;
			posTxt = "";
			foundFruits = 0;			
			nextLine(true, distanceLine/2, false);
		end;
		if moGuiMiniPdaSlots.fieldsInfo.seeGrowth and moFields[fieldNum].growthAreas ~= 0 then
			setTextBold(true);
			foundFruits = Utils.getNoNil(moFields[fieldNum].growthFruitsLength, 0);
			if foundFruits > 0 then posTxt = " (".. tostring(foundFruits).. ")";end;
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("f_growth", nil, "Growth")).. tostring(posTxt));
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);	
			renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].growthAreas).. "%");
			setTextAlignment(false);
			posTxt = "";
			if foundFruits > 0 and not seeSmall then
				nextLine(true, distanceLine/2, false);
				setTextBold(false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				posTxt = tostring(moLanguageXml:getTxt("f_level", nil, "Stage")).. "[".. tostring(moFields[fieldNum].growthLevel).. "]";
				renderText(posX, currentPosY, size, tostring(posTxt));
				setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
				setTextAlignment(RenderText.ALIGN_RIGHT);	
				renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].growthProzent).. "%");
				setTextAlignment(false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				posTxt = "";				
				nextLine(true, distanceLine/2, false);
				for k,v in pairs(moFields[fieldNum].growthFruits) do
					if string.len(posTxt) > 0 then posTxt = posTxt.. " | ".. v.fruitName.. " ".. v.areas.. "%";
					else posTxt = v.fruitName.. " ".. v.areas.. "%";end;
				end;
				renderText(posX, currentPosY, sizeTemp, tostring(posTxt));
			end;
			posTxt = "";
			foundFruits = 0;			
			nextLine(true, distanceLine/2, false);
		end;
		if moGuiMiniPdaSlots.fieldsInfo.seeFertilizer and moFields[fieldNum].fertilizerAreas ~= 0 then			
			setTextBold(true);
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("f_fertilizer", nil, "Sprayer")));
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);	
			renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].fertilizerAreas).. "%");
			setTextAlignment(false);					
			nextLine(true, distanceLine/2, false);
		end;
		if moGuiMiniPdaSlots.fieldsInfo.seeCut and moFields[fieldNum].cutAreas ~= 0 then
			setTextBold(true);
			foundFruits = Utils.getNoNil(moFields[fieldNum].cutFruitsLength, 0);
			if foundFruits > 0 then posTxt = " (".. tostring(foundFruits).. ")";end;
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("f_cut", nil, "Cut")).. tostring(posTxt));
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);	
			renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].cutAreas).. "%");
			setTextAlignment(false);
			posTxt = "";
			if foundFruits > 0 and not seeSmall then
				setTextBold(false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				nextLine(true, distanceLine/2, false);
				for k,v in pairs(moFields[fieldNum].cutFruits) do
					if string.len(posTxt) > 0 then posTxt = posTxt.. " | ".. v.fruitName.. " ".. v.areas.. "%";
					else posTxt = v.fruitName.. " ".. v.areas.. "%";end;
				end;
				renderText(posX, currentPosY, sizeTemp, tostring(posTxt));
			end;
			posTxt = "";
			foundFruits = 0;			
			nextLine(true, distanceLine/2, false);
		end;
		if moGuiMiniPdaSlots.fieldsInfo.seeRotten and moFields[fieldNum].rottenAreas ~= 0 then			
			setTextBold(true);
			foundFruits = Utils.getNoNil(moFields[fieldNum].rottenFruitsLength, 0);
			if foundFruits > 0 then posTxt = " (".. tostring(foundFruits).. ")";end;
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("b_rotten", nil, "Rotten")).. tostring(posTxt));
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);	
			renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].rottenAreas).. "%");
			setTextAlignment(false);
			posTxt = "";
			if foundFruits > 0 and not seeSmall then
				setTextBold(false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				nextLine(true, distanceLine/2, false);
				for k,v in pairs(moFields[fieldNum].rottenFruits) do
					if string.len(posTxt) > 0 then posTxt = posTxt.. " | ".. v.fruitName.. " ".. v.areas.. "%";
					else posTxt = v.fruitName.. " ".. v.areas.. "%";end;
				end;
				renderText(posX, currentPosY, sizeTemp, tostring(posTxt));
			end;
			posTxt = "";
			foundFruits = 0;			
			nextLine(true, distanceLine/2, false);
		end;
		if moGuiMiniPdaSlots.fieldsInfo.seePlough and moFields[fieldNum].ploughAreas ~= 0 then			
			setTextBold(true);
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("f_plough", nil, "Plough")));
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);	
			renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].ploughAreas).. "%");
			setTextAlignment(false);					
			nextLine(true, distanceLine/2, false);
		end;
		if moGuiMiniPdaSlots.fieldsInfo.seeWindrow and moFields[fieldNum].windrowAreas ~= 0 then
			setTextBold(true);
			foundFruits = Utils.getNoNil(moFields[fieldNum].windrowFruitsLength, 0);
			if foundFruits > 0 then posTxt = " (".. tostring(foundFruits).. ")";end;
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("f_windrow", nil, "Windrow")).. tostring(posTxt));
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);	
			renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].windrowAreas).. "%");
			setTextAlignment(false);
			posTxt = "";
			if foundFruits > 0 and not seeSmall then
				setTextBold(false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				nextLine(true, distanceLine/2, false);
				for k,v in pairs(moFields[fieldNum].windrowFruits) do
					if string.len(posTxt) > 0 then posTxt = posTxt.. " | ".. v.fruitName.. " ".. v.areas.. "%";
					else posTxt = v.fruitName.. " ".. v.areas.. "%";end;
				end;
				renderText(posX, currentPosY, sizeTemp, tostring(posTxt));
				--for k,v in pairs(moFields[fieldNum].windrowFruits) do
				--	if v.fillLevel ~= nil then
				--		nextLine(true, distanceLine/2, false);
				--		renderText(posX, currentPosY, sizeTemp, tostring(v.fruitName).. "(".. tostring(v.fillLevel).. "L)");					
				--	end;					
				--end;
			end;
			posTxt = "";
			foundFruits = 0;			
			nextLine(true, distanceLine/2, false);
		end;
		if moFields[fieldNum].unknownAreas ~= 0 and not seeSmall then			
			setTextBold(true);
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("unknow", nil, "Unknown")));
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextAlignment(RenderText.ALIGN_RIGHT);	
			renderText(posX+width-distanceDif, currentPosY, size, tostring(moFields[fieldNum].unknownAreas).. "%");
			setTextAlignment(false);					
			nextLine(true, distanceLine/2, false);
		end;
	--end;	
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-0.001, posY-height+heightDefault+0.007, width, height);
	setTextColor(1, 1, 1, 1);
	setTextAlignment(false);
	setTextBold(false);	
end;

function moDraw.extraFields:setClickAreaSeeSmall(self, posX, posY, horizontal, vertical, fruitTypesString, fieldNumString, slot)	
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), fruitTypesString, fieldNumString };
end;

--function moDraw.extraFields:setClickAreaFieldBuy(self, posX, posY, horizontal, vertical, fieldNum, slot)	
--	if fieldNum == nil then return;end;
--	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotFieldBuy), 0);	
--	moGuiMiniPdaSlots.values[slot].clickArea.slotFieldBuy[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), fieldNum };
--end;